Attribute VB_Name = "Addin"
'----------------------------------------------
' The Main Module
'----------------------------------------------
Option Explicit

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
    (ByVal AppName As String, ByVal KeyName As String, ByVal keydefault As String, _
    ByVal result As String, ByVal resultSize As Long, ByVal FileName As String) As Long
Private Declare Function WritePrivateProfileString& Lib "kernel32" Alias "WritePrivateProfileStringA" _
    (ByVal AppName$, ByVal KeyName$, ByVal keydefault$, ByVal FileName$)

'complete name of the connect class
Private Const ADDIN_CLASSNAME As String = "vbUnit3ST.Connect"
' where in the registry are kept relevant information
Private Const APP_CATEGORY = "Microsoft Visual Basic AddIns"

' the VBIDE instance connected to this addin
Sub Main()

End Sub

Sub RegisterAddIn(Optional LoadMode As String)
    '------------------------------------------------------------
    ' Add a reference in the VBADDIN.INI file
    '------------------------------------------------------------
    Dim result As String
    
    If LoadMode <> "1" Then LoadMode = "0"
    
    ' try to read the entry in VBADDIN.INI
    result = Space$(256)
    GetPrivateProfileString "Add-Ins32", ADDIN_CLASSNAME, "***", result, Len(result), "vbaddin.ini"
    If Left$(result, 3) = "***" Then
        ' the entry is not there, so we must record it
        WritePrivateProfileString "Add-Ins32", ADDIN_CLASSNAME, LoadMode, "vbaddin.ini"
    End If
End Sub

